<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="This module provides forward and reverse substring search routines."><meta name="keywords" content="rust, rustlang, rust-lang, memmem"><title>memchr::memmem - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc mod"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../memchr/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../memchr/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Module memmem</a></h2><div class="sidebar-elems"><section><div class="block"><ul><li><a href="#structs">Structs</a></li><li><a href="#enums">Enums</a></li><li><a href="#functions">Functions</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../memchr/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Module <a href="../index.html">memchr</a>::<wbr><a class="mod" href="#">memmem</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../../src/memchr/memmem/mod.rs.html#1-1321">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>This module provides forward and reverse substring search routines.</p>
<p>Unlike the standard library’s substring search routines, these work on
arbitrary bytes. For all non-empty needles, these routines will report exactly
the same values as the corresponding routines in the standard library. For
the empty needle, the standard library reports matches only at valid UTF-8
boundaries, where as these routines will report matches at every position.</p>
<p>Other than being able to work on arbitrary bytes, the primary reason to prefer
these routines over the standard library routines is that these will generally
be faster. In some cases, significantly so.</p>
<h2 id="example-iterating-over-substring-matches"><a href="#example-iterating-over-substring-matches">Example: iterating over substring matches</a></h2>
<p>This example shows how to use <a href="fn.find_iter.html" title="find_iter"><code>find_iter</code></a> to find occurrences of a substring
in a haystack.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">memchr::memmem</span>;

<span class="kw">let</span> <span class="ident">haystack</span> <span class="op">=</span> <span class="string">b&quot;foo bar foo baz foo&quot;</span>;

<span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">it</span> <span class="op">=</span> <span class="ident">memmem::find_iter</span>(<span class="ident">haystack</span>, <span class="string">&quot;foo&quot;</span>);
<span class="macro">assert_eq!</span>(<span class="prelude-val">Some</span>(<span class="number">0</span>), <span class="ident">it</span>.<span class="ident">next</span>());
<span class="macro">assert_eq!</span>(<span class="prelude-val">Some</span>(<span class="number">8</span>), <span class="ident">it</span>.<span class="ident">next</span>());
<span class="macro">assert_eq!</span>(<span class="prelude-val">Some</span>(<span class="number">16</span>), <span class="ident">it</span>.<span class="ident">next</span>());
<span class="macro">assert_eq!</span>(<span class="prelude-val">None</span>, <span class="ident">it</span>.<span class="ident">next</span>());</code></pre></div>
<h2 id="example-iterating-over-substring-matches-in-reverse"><a href="#example-iterating-over-substring-matches-in-reverse">Example: iterating over substring matches in reverse</a></h2>
<p>This example shows how to use <a href="fn.rfind_iter.html" title="rfind_iter"><code>rfind_iter</code></a> to find occurrences of a substring
in a haystack starting from the end of the haystack.</p>
<p><strong>NOTE:</strong> This module does not implement double ended iterators, so reverse
searches aren’t done by calling <code>rev</code> on a forward iterator.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">memchr::memmem</span>;

<span class="kw">let</span> <span class="ident">haystack</span> <span class="op">=</span> <span class="string">b&quot;foo bar foo baz foo&quot;</span>;

<span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">it</span> <span class="op">=</span> <span class="ident">memmem::rfind_iter</span>(<span class="ident">haystack</span>, <span class="string">&quot;foo&quot;</span>);
<span class="macro">assert_eq!</span>(<span class="prelude-val">Some</span>(<span class="number">16</span>), <span class="ident">it</span>.<span class="ident">next</span>());
<span class="macro">assert_eq!</span>(<span class="prelude-val">Some</span>(<span class="number">8</span>), <span class="ident">it</span>.<span class="ident">next</span>());
<span class="macro">assert_eq!</span>(<span class="prelude-val">Some</span>(<span class="number">0</span>), <span class="ident">it</span>.<span class="ident">next</span>());
<span class="macro">assert_eq!</span>(<span class="prelude-val">None</span>, <span class="ident">it</span>.<span class="ident">next</span>());</code></pre></div>
<h2 id="example-repeating-a-search-for-the-same-needle"><a href="#example-repeating-a-search-for-the-same-needle">Example: repeating a search for the same needle</a></h2>
<p>It may be possible for the overhead of constructing a substring searcher to be
measurable in some workloads. In cases where the same needle is used to search
many haystacks, it is possible to do construction once and thus to avoid it for
subsequent searches. This can be done with a <a href="struct.Finder.html" title="Finder"><code>Finder</code></a> (or a <a href="struct.FinderRev.html" title="FinderRev"><code>FinderRev</code></a> for
reverse searches).</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">memchr::memmem</span>;

<span class="kw">let</span> <span class="ident">finder</span> <span class="op">=</span> <span class="ident">memmem::Finder::new</span>(<span class="string">&quot;foo&quot;</span>);

<span class="macro">assert_eq!</span>(<span class="prelude-val">Some</span>(<span class="number">4</span>), <span class="ident">finder</span>.<span class="ident">find</span>(<span class="string">b&quot;baz foo quux&quot;</span>));
<span class="macro">assert_eq!</span>(<span class="prelude-val">None</span>, <span class="ident">finder</span>.<span class="ident">find</span>(<span class="string">b&quot;quux baz bar&quot;</span>));</code></pre></div>
</div></details><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.FindIter.html" title="memchr::memmem::FindIter struct">FindIter</a></div><div class="item-right docblock-short"><p>An iterator over non-overlapping substring matches.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.FindRevIter.html" title="memchr::memmem::FindRevIter struct">FindRevIter</a></div><div class="item-right docblock-short"><p>An iterator over non-overlapping substring matches in reverse.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Finder.html" title="memchr::memmem::Finder struct">Finder</a></div><div class="item-right docblock-short"><p>A single substring searcher fixed to a particular needle.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.FinderBuilder.html" title="memchr::memmem::FinderBuilder struct">FinderBuilder</a></div><div class="item-right docblock-short"><p>A builder for constructing non-default forward or reverse memmem finders.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.FinderRev.html" title="memchr::memmem::FinderRev struct">FinderRev</a></div><div class="item-right docblock-short"><p>A single substring reverse searcher fixed to a particular needle.</p>
</div></div></div><h2 id="enums" class="small-section-header"><a href="#enums">Enums</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.Prefilter.html" title="memchr::memmem::Prefilter enum">Prefilter</a></div><div class="item-right docblock-short"><p>Prefilter controls whether heuristics are used to accelerate searching.</p>
</div></div></div><h2 id="functions" class="small-section-header"><a href="#functions">Functions</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.find.html" title="memchr::memmem::find fn">find</a></div><div class="item-right docblock-short"><p>Returns the index of the first occurrence of the given needle.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.find_iter.html" title="memchr::memmem::find_iter fn">find_iter</a></div><div class="item-right docblock-short"><p>Returns an iterator over all non-overlapping occurrences of a substring in
a haystack.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.rfind.html" title="memchr::memmem::rfind fn">rfind</a></div><div class="item-right docblock-short"><p>Returns the index of the last occurrence of the given needle.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.rfind_iter.html" title="memchr::memmem::rfind_iter fn">rfind_iter</a></div><div class="item-right docblock-short"><p>Returns a reverse iterator over all non-overlapping occurrences of a
substring in a haystack.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="memchr" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>